--[[
	written by Seryn
	version 1.0
	based on mdi-targetlist tab system by draugath
--]]

declare("Cargo_tab", {
	version = "1.0.0",
})


local T = {
	Tab = {
		title = "Cargo",
		columns = {
			{
				title = "Index",
				width = 0,
			},
			{
				title = "Item",
				width = 1,
			},
		},
		filters = {
			{
				title = "Cargo",
			},
		},
		--------------
		

		cargoList = { 
			{
				"1",
				"\12700edf5Synthetic Silksteel",
			},
			{
				"2",
				"\1270084ffNeural Nodules",
			},
			{ 
				"3",
				"\127ffbb00Processor Cores",
			},
			{	
				"4",
				"\1278400ffAvalon Torpedos",
			},
			{	
				"5",
				"\12736ff83Hive Queen drops",
			},
			{	
				"6",
				"\127007d5eLaw Enforcement Neutron Blaster",
			},
			{	
				"7",
				"\127ff4800Rarified Heliocene Alloy",
			},
			{	
				"8",
				"\127ff00f7Data Aggregator",
			},
			{	
				"9",
				"\127ffda73Samoflange",
			}
		},
		filter_index = -1,
	}
}

Cargo_tab.T = T


local setRadarSelection = radar.SetRadarSelection
local pCommand = gkinterface.GKProcessCommand

-- tab change to Cargo, update list.. maybe useful later
function T.Tab:TARGETLIST_TAB_CHANGED()
	self.is_active = targetlist.API.IsActiveTab(T.Tab)
	if (self.is_active) then
		targetlist.API.UpdateDisplay(self, self.cargoList)
	end
end

-- select target to find cargo 
function T.Tab:ChangeTarget(_, listEntryID)
	local listEntryID = listEntryID
	local searchItem = " "
	-- search for silksteel
	if listEntryID == 1 then
		searchItem = "Synthetic Silksteel"
	-- search for nodules
	elseif listEntryID == 2 then
		searchItem = "Neural Nodule"
	-- search for processor cores
	elseif listEntryID == 3 then
		searchItem = "Processor Core"
	-- search for Avalons
	elseif listEntryID == 4 then
		searchItem = "Avalon"
	-- search queen drops
	elseif listEntryID == 5 then
		searchItem = "Queen"
	-- find lenb
	elseif listEntryID == 6 then
		searchItem = "Law Enforcement"
	-- search rarified heliocene alloy
	elseif listEntryID == 7 then
		searchItem = "Rarified Heliocene"
	-- find data aggy
	elseif listEntryID == 8 then
		searchItem = "Data Aggregator"
	-- find samoflange
	elseif listEntryID == 9 then
		searchItem = "Samoflange"
	end

	local currentItem = " "
	local itemFound = 0
	-- start radar search at zero
	setRadarSelection(0,0)
	-- search through all items in range until something matches
	while (currentItem ~= nil and itemFound == 0) do
		pCommand("RadarNext");
		-- check found item 
		currentItem = GetTargetInfo()
		-- compare current item with the search item
		if (currentItem ~= nil and string.find(string.lower(currentItem),string.lower(searchItem))) then
			-- end the loop, cargo found
			itemFound = 1
		end
	end
	-- nothing found, still zero
	if itemFound == 0 then
		print("\127504aff** No cargo in range with: " .. searchItem .. "\127o")
	end
end


-- check if plugin was loaded correctly
function T.Tab:PLUGINS_LOADED()
	if (isdeclared("targetlist") and targetlist.API) then
		if (targetlist.API.Version >= 1) then
			targetlist.API.RegisterTab(T.Tab)
		else
			print("\127504affMDI-TargetList API version is not compatible. Cargo Tab was not loaded.\127o")
		end
	end
end

-- check if targetlist is even installed
function T.Tab:PLAYER_ENTERED_GAME()
	if (not (isdeclared("targetlist") and targetlist.API)) then
		print("\127504affCargo Tab for MDI-TargetList requires version 4 or higher.\127o")
	end
end


RegisterEvent(T.Tab, "TARGETLIST_TAB_CHANGED")
RegisterEvent(T.Tab, "PLUGINS_LOADED")
RegisterEvent(T.Tab, "PLAYER_ENTERED_GAME")
